<template>
  <ValidationObserver v-slot="{handleSubmit}">
    <form novalidate
          @submit.prevent="handleSubmit(saveUserForm)"
          class="profile">
      <h1 class="profile__title">Профиль</h1>
      <div class="profile__wrapper">
        <ValidationProvider
          class="profile__input-wrapper"
          v-slot="{errors}"
          name="name"
          rules="required">
          <form-input class="profile__input"
                      v-model="user.name"
                      :error="Boolean(errors.length)"
                      label="Имя"
                      name="name"
          />
        </ValidationProvider>

        <div class="profile__input-wrapper">
          <form-input class="profile__input"
                      v-model="user.surname"
                      label="Фамилия"
          />
        </div>

        <ValidationProvider
          class="profile__input-wrapper"
          v-slot="{errors, failedRules}"
          name="email"
          :customMessages="{ regex: 'Email введен неверно' }"
          :rules="{ regex: /^[-a-z0-9!#$%&'*+\/=?^_`{|}~]+(?:\.[-a-z0-9!#$%&'*+\/=?^_`{|}~]+)*@(?:[a-z0-9]([-a-z0-9]{0,61}[a-z0-9])?\.)*(?:aero|arpa|asia|biz|cat|com|coop|edu|gov|info|int|jobs|mil|mobi|museum|name|net|org|pro|tel|travel|[a-z][a-z])$/gmi, required: true }">
          <form-input class="profile__input"
                      v-model="user.email"
                      :error="Boolean(errors.length)"
                      :label="failedRules.regex ? failedRules.regex : 'Email'"
                      name="email"
                      :readonly="isEmailFilled"
          />
        </ValidationProvider>

        <div class="profile__input-wrapper">
          <form-input class="profile__input"
                      label="Телефон"
                      type="tel"
                      v-model="user.phone"
                      :mask="true"
                      mask-type="phone-mask"
                      :readonly="true"
          />
        </div>
      </div>

      <button type="submit"
              class="button button--green profile__button">
        Сохранить
      </button>
    </form>
  </ValidationObserver>
</template>

<script>
  import { mapActions } from 'vuex';
  import {ValidationObserver, ValidationProvider} from 'vee-validate';

  import FormInput from '../../components/FormInput';

  import { getSeoBySlug } from '../../service/deliroom-service';

  export default {
    name: 'ProfilePage',
    middleware: 'auth',
    components: {
      ValidationObserver,
      ValidationProvider,
      FormInput
    },
    data: () => ({
      user: {
        name: null,
        surname: null,
        email: null,
        phone: null,
      }
    }),

    asyncData: async () => ({
      meta: await getSeoBySlug('/personal/profile'),
    }),

    beforeMount() {
      this.user = { ...this.$store.state.user.user }
    },

    computed: {
      isEmailFilled() {
        return !!this.$store.state.user.user.email;
      }
    },

    methods: {
      ...mapActions({
        saveUser: 'user/saveUser'
      }),

      async saveUserForm() {
        await this.saveUser(this.user);
      },
    },

    head() {
      if (!this.meta) return;

      return {
        title: this.meta.title,
        meta: this.meta.meta.map((metaItem) => ({
          ...metaItem,
          hid: metaItem.name.toLowerCase(),
          name: metaItem.name.toLowerCase(),
        })),
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .profile {
    &__title {
      @include h2;

      margin-bottom: rem(50);

      @media (max-width: $mobile-width) {
        margin-bottom: rem(30);
      }
    }

    &__wrapper {
      display: flex;
      flex-flow: wrap;

      margin: rem(-14);

      @media (max-width: $mobile-width) {
        margin: 0;
      }
    }

    &__input-wrapper {
      flex: 0 0 calc(50% - 1.75rem);
      width: calc(50% - 1.75rem);
      margin: rem(14);

      @media (max-width: $mobile-width) {
        flex: 0 0 100%;
        width: 100%;
        margin: 0;

        &:not(:first-child) {
          margin-top: rem(12);
        }
      }
    }

    &__button {
      margin-top: rem(40);

      @media (max-width: $mobile-width) {
        margin-top: rem(24);
        width: 100%;
      }
    }
  }
</style>

